//Psychlops Code Template
//    Please visit following web site to get sample codes.
//    http://psychlops.sourceforge.jp/ja/?StartCode
//    CodeDresser at following address is also available to view the code.
//    http://visitope.org/Tools/codedresser.html

//hoge

///+ 0 Setup Psychlops Circumstances
//// 0 Setup Psychlops Circumstances
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/video/tracking.hpp>
#include <opencv2/features2d/features2d.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <psychlops.h>
//#include "psychlops_ext_cv1.h"
using namespace Psychlops;
// Psychlops Win32 1.6.0 / 20120220
///- 0 Setup Psychlops Circumstances


void psychlops_main() {


	///+ 1 Declaration /////////////////////////////////////////////////////////////
	//// 1 Declaration
		// declare default window and variables for its parameters
		Canvas cnvs(Canvas::window, Display::secondary);
		double CANVAS_FRAMENUM;
		int CANVAS_REFRESHRATE;
		Psychlops::Color DEFAULT_BG_COLOR;

		//declare local variables around here

	///- 1 Declaration /////////////////////////////////////////////////////////////

	///+ 2 Initialization //////////////////////////////////////////////////////////
	//// 2 Initialization

		// Set initial values for local variables
		CANVAS_REFRESHRATE = cnvs.getRefreshRate();
		CANVAS_FRAMENUM = 0;
		DEFAULT_BG_COLOR.set(127.0/255.0,127.0/255.0,127.0/255.0,1.0); // default background color is 127/255 mid-gray

		//cv2
		cv::VideoCapture cap(0);
		if(!cap.isOpened()) {
			std::cout << "Camera was not found." << std::endl;
			exit(20);
		}
		cv::Mat camera_mat, camera_mat_prev;
		// ensure the existance of the reference reImage
        cap >> camera_mat;

		Image img1, img2, camimg;


		std::vector<cv::KeyPoint> keypoints;
		std::vector<cv::Point2f> oldpoints;
		std::vector<cv::Point2f> newpoints;
		std::vector<uchar> status;
		std::vector<float> errors;

		Psychlops::Figures::Arrow motion_vector_arrow;
		motion_vector_arrow.stroke.set(Color(1.0, 0.0, 0.0, 0.5), 1, Stroke::SOLID);
		Psychlops::Point img_datum;



		cv::FastFeatureDetector detector(10);
		//cv::GoodFeaturesToTrackDetector detector(30, 0.05, 5, 3);

		Figures::Movie movie;
		movie.source_area.set(500,500).centering();

	///- 2 Initialization //////////////////////////////////////////////////////////

	///+ 3 Drawing /////////////////////////////////////////////////////////////////
	while(!Input::get(Keyboard::esc)) {
		cnvs.clear(DEFAULT_BG_COLOR);

		// update camera input
		//camera_mat.copyTo(camera_mat_prev);
        cap >> camera_mat;
/*
		// refresh data cache
		keypoints.clear();
		oldpoints.clear();
		newpoints.clear();

		// detect good points
		detector.detect(camera_mat_prev, keypoints);
		for(std::vector<cv::KeyPoint>::iterator itk = keypoints.begin(); itk != keypoints.end(); ++itk)
		{
			oldpoints.push_back(itk->pt);
		}
		newpoints.reserve(oldpoints.capacity());

		// calc optical flow
        cv::calcOpticalFlowPyrLK(camera_mat_prev, camera_mat, oldpoints, newpoints, status, errors
								, cv::Size(15,15) // maximum search box
								, 3 // Max level
								, cvTermCriteria (CV_TERMCRIT_ITER | CV_TERMCRIT_EPS, 30, 0.01)
								, 0.5 // derivLambda
								);



		// draw
*/
        camimg.from(camera_mat);
		camimg.centering().draw();
		//FFT2::filterImage(camimg, img1, 10, 10, 1.0);
/*
		img_datum = camimg.getDatum();
		for(int i=0; i<oldpoints.size(); i++)
		{
			motion_vector_arrow.set(oldpoints[i].x, oldpoints[i].y, newpoints[i].x, newpoints[i].y);
			motion_vector_arrow.shift(img_datum.x, img_datum.y);
			motion_vector_arrow.draw();
		}
*/
		//movie.captureOnce();
		cnvs.flip();
		CANVAS_FRAMENUM++;
	}
	///- 3 Drawing /////////////////////////////////////////////////////////////////

	//movie.save("test.avi", 15);
	//cv1
    //cvReleaseCapture( &videoCapture );
}
